# SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause
%YAML 1.2
---
$id: http://devicetree.org/schemas/net/nfc/st,st-nci.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: STMicroelectronics ST NCI NFC controller

maintainers:
  - Krzysztof Kozlowski <krzysztof.kozlowski@canonical.com>

properties:
  compatible:
    enum:
      - st,st21nfcb-i2c
      - st,st21nfcb-spi
      - st,st21nfcc-i2c

  reset-gpios:
    description: Output GPIO pin used for resetting the controller

  ese-present:
    type: boolean
    description: |
      Specifies that an ese is physically connected to the controller

  interrupts:
    maxItems: 1

  reg:
    maxItems: 1

  spi-max-frequency: true

  uicc-present:
    type: boolean
    description: |
      Specifies that the uicc swp signal can be physically connected to the
      controller

required:
  - compatible
  - interrupts
  - reg
  - reset-gpios

if:
  properties:
    compatible:
      contains:
        enum:
          - st,st21nfcb-i2c
          - st,st21nfcc-i2c
then:
  properties:
    spi-max-frequency: false
else:
  required:
    - spi-max-frequency

additionalProperties: false

examples:
  - |
    #include <dt-bindings/gpio/gpio.h>
    #include <dt-bindings/interrupt-controller/irq.h>

    i2c {
        #address-cells = <1>;
        #size-cells = <0>;

        nfc@8 {
            compatible = "st,st21nfcb-i2c";
            reg = <0x08>;

            interrupt-parent = <&gpio5>;
            interrupts = <2 IRQ_TYPE_LEVEL_HIGH>;
            reset-gpios = <&gpio5 29 GPIO_ACTIVE_HIGH>;

            ese-present;
            uicc-present;
        };
    };

  - |
    #include <dt-bindings/gpio/gpio.h>
    #include <dt-bindings/interrupt-controller/irq.h>

    spi {
        #address-cells = <1>;
        #size-cells = <0>;

        nfc@0 {
            compatible = "st,st21nfcb-spi";
            reg = <0>;

            spi-max-frequency = <4000000>;

            interrupt-parent = <&gpio5>;
            interrupts = <2 IRQ_TYPE_EDGE_RISING>;
            reset-gpios = <&gpio5 29 GPIO_ACTIVE_HIGH>;

            ese-present;
            uicc-present;
        };
    };
